/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 1111
#ifdef HAVE_CONFIG_H
#line 1111
# include <config.h>
#line 1111
#endif
#line 1111
#include <sys/types.h>
#line 1111

#line 1111
#include "mailfromd.h"
#line 1111
#include "prog.h"
#line 1111
#include "builtin.h"
#line 1111

#line 178 "io.bi"
static mu_debug_handle_t debug_handle;
#line 1111 "io.bi"

#line 767 "../../src/builtin/snarf.m4"

#line 1 "io.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006-2011, 2015 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <mflib/status.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include "global.h"
#include "msg.h"

static size_t nstreams = MAX_IOSTREAMS;

static struct mu_cfg_param io_cfg_param[] = {
	{ "max-streams", mu_cfg_size, &nstreams, 0, NULL,
	  N_("Maximum number of stream descriptors.") },
	{ NULL }
};

struct io_stream {
	char *name;
	mu_locker_t lock;
	int fd[2];
	pid_t pid;
	char *buf;
	size_t bufsize;
	int (*shutdown)(struct io_stream *, int what);
	void (*cleanup)(void*);
	void *cleanup_data;
	char *delim;
};

#define IFD(s) ((s).fd[0])
#define OFD(s) ((s).fd[1] == -1 ? (s).fd[0] : (s).fd[1])

static void
flush_stream(struct io_stream *str)
{
	/*FIXME*/
}

static void
close_stream(struct io_stream *str)
{
	if (OFD(*str) == -1)
		return;
	flush_stream(str);
	close(OFD(*str));
	if (IFD(*str) != -1)
		close(IFD(*str));
	if (str->pid) {
		int status;
		waitpid(str->pid, &status, 0);
	}
	str->fd[0] = -1;
	str->fd[1] = -1;
	str->pid = 0;
	if (str->cleanup)
		str->cleanup(str->cleanup_data);
	str->cleanup = NULL;
	str->cleanup_data = NULL;
	if (str->name) {
		free(str->name);
		str->name = NULL;
	}
	if (str->delim) {
		free(str->delim);
		str->delim = NULL;
	}
}

/* Read bytes from the stream STR into its buffer, until
   DELIM is encountered. Return number of bytes read. */
static int
read_stream_delim(struct io_stream *str, char *delim)
{
	int fd = IFD(*str);
	size_t i = 0;
	int rc;
	size_t delim_len = strlen(delim);
	
	for (;;) {
		if (str->bufsize == i) {
			if (str->bufsize == 0) 
				str->bufsize = 16;
			str->buf = mu_2nrealloc(str->buf, &str->bufsize,
					      sizeof str->buf[1]);
		}
		rc = read(fd, str->buf + i, 1);
		if (rc == -1)
			return -1;
		else if (rc == 0)
			return 0;
		i++;
		if (i >= delim_len &&
		    memcmp(str->buf + i - delim_len, delim, delim_len) == 0) {
			str->buf[i - delim_len] = 0;
			break;
		}
	}
	return i;
}

#define REDIRECT_STDIN_P(f) ((f) & (O_WRONLY|O_RDWR))
#define REDIRECT_STDOUT_P(f) (!((f) & O_WRONLY))

#define STDERR_SHUT        0
#define STDERR_NULL        1
#define STDERR_LOG         2
#define STDERR_FILE        3
#define STDERR_FILE_APPEND 4

#define LOG_TAG_PFX "mailfromd:"
#define LOG_TAG_PFX_LEN (sizeof(LOG_TAG_PFX)-1)

static void
stderr_to_log(char *arg, const char *cmd)
{
	int p[2];
	pid_t pid;
	
	if (pipe(p)) {
		mu_error(_("pipe failed: %s"), mu_strerror(errno));
		close(2);
		return;
	}

	pid = fork();

	if (pid == (pid_t) -1) {
		mu_error(_("fork failed: %s"), mu_strerror(errno));
		close(p[0]);
		close(p[1]);
		close(2);
		return;
	}
	
	/* Child */
	if (pid == 0) {
		FILE *fp;
		fd_set fdset;
		size_t len;
		char buf[1024];
		char *tag;
		int fac = mu_log_facility, pri = LOG_ERR;
		
		if (arg) {
			char *p = strchr(arg, '.');

			if (p)
				*p++ = 0;
			if (mu_string_to_syslog_facility(arg, &fac)) {
				mu_error(_("unknown syslog facility (%s), "
					   "redirecting stderr to %s"),
					 arg,
					 mu_syslog_facility_to_string(fac));
			}
			
			if (p && mu_string_to_syslog_priority(p, &pri)) {
				mu_error(_("unknown syslog priority (%s), "
					   "redirecting stderr to %s"),
					 arg,
					 mu_syslog_priority_to_string(pri));
			}
		}
		
#line 178 "io.bi"

#line 178
mu_debug(debug_handle, 10,("redirecting stderr to syslog %s.%s",
		           mu_syslog_facility_to_string(fac),
		           mu_syslog_priority_to_string(pri)));
#line 182
		
		len = strcspn(cmd, " \t");
		tag = malloc(LOG_TAG_PFX_LEN + len + 1);
		if (!tag)
			tag = (char*) cmd;
		else {
			strcpy(tag, LOG_TAG_PFX);
			memcpy(tag + LOG_TAG_PFX_LEN, cmd, len);
			tag[LOG_TAG_PFX_LEN + len] = 0;
		}
		mf_proctitle_format("%s redirector", cmd);

		FD_ZERO(&fdset);
		FD_SET(p[0], &fdset);
		logger_fdset(&fdset);
		close_fds_except(&fdset);

		fp = fdopen(p[0], "r");
		logger_open();
		while (fgets(buf, sizeof(buf), fp))
			syslog(pri, "%s", buf);
		exit(0);
	}

	/* Parent */
	close(p[0]);
	dup2(p[1], 2);
	close(p[1]);
}
	
static void
stderr_handler(int mode, char *arg, const char *cmd)
{
	int fd;
	int append = O_TRUNC;
	
	switch (mode) {
	case STDERR_SHUT:
		close(2);
		break;

	case STDERR_NULL:
		arg = "/dev/null";
	case STDERR_FILE_APPEND:
		append = O_APPEND;
	case STDERR_FILE:
		if (!arg || !*arg) {
			close(2);
			break;
		}
		
#line 232

#line 232
mu_debug(debug_handle, 10,("redirecting stderr to %s", arg));
		fd = open(arg, O_CREAT|O_WRONLY|append, 0644);
		if (fd < 0) {
			mu_error(_("cannot open file %s for appending: %s"),
				 arg, mu_strerror(errno));
			close(2);
			return;
		}
		if (fd != 2) {
			dup2(fd, 2);
			close(fd);
		}
		break;

	case STDERR_LOG:
		stderr_to_log(arg, cmd);
	}
}

static void
parse_stderr_redirect(const char **pcmd, int *perr, char **parg)
{
	int err;
	size_t len;
	char *arg;
	const char *cmdline = *pcmd;
	
	while (*cmdline && mu_isspace(*cmdline))
		cmdline++;
	if (strncmp(cmdline, "2>file:", 7) == 0) {
		cmdline += 7;
		err = STDERR_FILE;
	} else if (strncmp(cmdline, "2>>file:", 8) == 0) {
		cmdline += 8;
		err = STDERR_FILE_APPEND;
	} else if (strncmp(cmdline, "2>null:", 7) == 0) {
		cmdline += 7;
		err = STDERR_NULL;
	} else if (strncmp(cmdline, "2>syslog:", 9) == 0) {
		cmdline += 9;
		err = STDERR_LOG;
	} else
		return;

	len = strcspn(cmdline, " \t");
	if (len > 0 && cmdline[len-1] == 0)
		return;
	if (len == 0)
		arg = NULL;
	else {
		arg = malloc(len + 1);
		if (!arg)
			return;
		memcpy(arg, cmdline, len);
		arg[len] = 0;
	}

	*pcmd = cmdline + len;
	*perr = err;
	*parg = arg;
}


static int
open_program_stream_ioe(eval_environ_t env,
			struct io_stream *str, const char *cmdline,
			int flags,
			int ioe[2])
{
	int rightp[2], leftp[2];
	int rc = 0;
	pid_t pid;
	int err = STDERR_SHUT;
	char *arg = NULL;
	struct mu_wordsplit ws;
	
	parse_stderr_redirect(&cmdline, &err, &arg);
	while (*cmdline && (*cmdline == ' ' || *cmdline == '\t'))
		cmdline++;
	
	if (REDIRECT_STDIN_P(flags))
		pipe(leftp);
	if (REDIRECT_STDOUT_P(flags))
		pipe(rightp);

	switch (pid = fork()) {
		/* The child branch.  */
	case 0:
		/* attach the pipes */

		/* Right-end */
		if (REDIRECT_STDOUT_P(flags)) {
			if (rightp[1] != 1)
				dup2(rightp[1], 1);
		} else if (ioe && ioe[1] != -1 && ioe[1] != 1) {
			dup2(ioe[1], 1);
		}

		/* Left-end */
		if (REDIRECT_STDIN_P(flags)) {
			if (leftp[0] != 0)
				dup2(leftp[0], 0);
		} else if (ioe && ioe[0] != -1 && ioe[0] != 0) {
			dup2(ioe[0], 0);
		}

		if (ioe && ioe[2] != -1 && ioe[2] != 2)
			dup2(ioe[2], 2);
		else
			stderr_handler(err, arg, cmdline);
		
		/* Close unneded descripitors */
		close_fds_above(2);

		
#line 346

#line 346
mu_debug(debug_handle, 10,("running %s", cmdline));
		if (mu_wordsplit(cmdline, &ws, MU_WRDSF_DEFFLAGS)) {
			mu_error(_("cannot parse command line %s: %s"),
				 cmdline, mu_wordsplit_strerror(&ws));
			exit(127);
		}
		execvp(ws.ws_wordv[0], ws.ws_wordv);
		mu_error(_("cannot run %s: %s"),
			 cmdline, mu_strerror(errno));
		exit(127);
		/********************/

		/* Parent branches: */
	case -1:
		/* Fork has failed */
		/* Restore things */
		rc = errno;
		if (REDIRECT_STDOUT_P(flags)) {
			close(rightp[0]);
			close(rightp[1]);
		}
		if (REDIRECT_STDIN_P(flags)) {
			close(leftp[0]);
			close(leftp[1]);
		}
		break;
		
	default:
		str->pid = pid;
		if (REDIRECT_STDOUT_P(flags)) {
			str->fd[0] = rightp[0];
			close(rightp[1]);
		} else
			str->fd[0] = -1;

		if (REDIRECT_STDIN_P(flags)) {
			str->fd[1] = leftp[1];
			close(leftp[0]);
		} else
			str->fd[1] = -1;
	}
	free(arg);
	return rc;
}

static int
open_program_stream(eval_environ_t env,
		    struct io_stream *str, const char *cmdline,
		    int flags)
{
	return open_program_stream_ioe(env, str, cmdline, flags, NULL);
}

static int
open_file_stream(eval_environ_t env,
		 struct io_stream *str, const char *file, int flags)
{
	str->fd[0] = open(file, flags, 0644); /* FIXME: mode? */
	if (str->fd[0] == -1)
		return errno;
	return 0;
}



static int
open_parsed_inet_stream(eval_environ_t env,
			struct io_stream *str,
			const char *cstr,
			char *proto, char *port, char *path,
			int flags)
{
	union {
		struct sockaddr sa;
		struct sockaddr_in s_in;
		struct sockaddr_un s_un;
#ifdef GACOPYZ_IPV6
		struct sockaddr_in6 s_in6;
#endif
	} addr;

	socklen_t socklen;
	int fd;
	int rc;

	if (!proto
	    || strcmp(proto, "unix") == 0 || strcmp(proto, "local") == 0) {
		struct stat st;
		
			if (!(port == NULL))
#line 435
		(
#line 435
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: %s; "
			    "port is meaningless for UNIX sockets"),cstr)
#line 435
)
#line 439
;
		
			if (!(strlen(path) <= sizeof addr.s_un.sun_path))
#line 441
		(
#line 441
	env_throw_bi(env, mfe_range, NULL, _("%s: UNIX socket name too long"),path)
#line 441
)
#line 444
;
		
		addr.sa.sa_family = PF_UNIX;
		socklen = sizeof(addr.s_un);
		strcpy(addr.s_un.sun_path, path);
		
		if (stat(path, &st)) {
			(
#line 451
	env_throw_bi(env, mfe_failure, NULL, _("%s: cannot stat socket: %s"),path,strerror(errno))
#line 451
);
#line 454
		} else {
			/* FIXME: Check permissions? */
				if (!(S_ISSOCK(st.st_mode)))
#line 456
		(
#line 456
	env_throw_bi(env, mfe_failure, NULL, _("%s: not a socket"),path)
#line 456
)
#line 459
;
		}

	} else if (strcmp(proto, "inet") == 0) {
		short pnum;
		long num;
		char *p;
		
		addr.sa.sa_family = PF_INET;
		socklen = sizeof(addr.s_in);

			if (!(port != NULL))
#line 470
		(
#line 470
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: %s; "
			    "missing port number"),cstr)
#line 470
)
#line 474
;

		num = pnum = strtol(port, &p, 0);
		if (*p == 0) {
				if (!(num == pnum))
#line 478
		(
#line 478
	env_throw_bi(env, mfe_range, NULL, _("invalid connection type: "
				    "%s; bad port number"),cstr)
#line 478
)
#line 482
;
			pnum = htons(pnum);
		} else {
			struct servent *sp = getservbyname(port, "tcp");

				if (!(sp != NULL))
#line 487
		(
#line 487
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: "
				    "%s; unknown port name"),cstr)
#line 487
)
#line 491
;
			pnum = sp->s_port;
		}
		
		if (!path)
			addr.s_in.sin_addr.s_addr = INADDR_ANY;
		else {
			struct hostent *hp = gethostbyname(path);
				if (!(hp != NULL))
#line 499
		(
#line 499
	env_throw_bi(env, mfe_failure, NULL, _("unknown host name %s"),path)
#line 499
)
#line 502
;
			addr.sa.sa_family = hp->h_addrtype;
			switch (hp->h_addrtype) {
			case AF_INET:
				memmove(&addr.s_in.sin_addr, hp->h_addr, 4);
				addr.s_in.sin_port = pnum;
				break;

			default:
				(
#line 511
	env_throw_bi(env, mfe_range, NULL, _("invalid connection type: "
					   "%s; unsupported address family"),cstr)
#line 511
);
#line 515
			}
		}
#ifdef GACOPYZ_IPV6
	} else if (strcmp(proto, "inet6") == 0) {
		struct addrinfo hints;
		struct addrinfo *res;
		
			if (!(port != NULL))
#line 522
		(
#line 522
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: %s; "
			    "missing port number"),cstr)
#line 522
)
#line 526
;

		memset(&hints, 0, sizeof(hints));
		hints.ai_family = AF_INET6;
		hints.ai_socktype = SOCK_STREAM;
		if (!path)
			hints.ai_flags |= AI_PASSIVE;
		
		rc = getaddrinfo(path, port, &hints, &res);
				
		switch (rc) {
		case 0:
			break;
			
		case EAI_SYSTEM:
			(
#line 541
	env_throw_bi(env, mfe_failure, NULL, _("%s:%s: cannot parse address: %s"),path,port,strerror(errno))
#line 541
);
#line 544
			
		case EAI_BADFLAGS:
		case EAI_SOCKTYPE:
			(
#line 547
	env_throw_bi(env, mfe_failure, NULL, _("%s:%d: internal error converting %s:%s"),__FILE__,__LINE__,path,port)
#line 547
);
#line 550
			
		case EAI_MEMORY:
			mu_alloc_die();
			
		default:
			(
#line 555
	env_throw_bi(env, mfe_failure, NULL, "%s:%s: %s",path,port,gai_strerror(rc))
#line 555
);
#line 558
		}

		socklen = res->ai_addrlen;
		if (socklen > sizeof(addr)) {
			freeaddrinfo(res);
			(
#line 563
	env_throw_bi(env, mfe_failure, NULL, _("%s:%s: address length too big (%lu)"),path,port,(unsigned long) socklen)
#line 563
);
#line 567
		}
		memcpy(&addr, res->ai_addr, res->ai_addrlen);
		freeaddrinfo(res);
#endif
	} else {
		(
#line 572
	env_throw_bi(env, mfe_range, NULL, _("unsupported protocol: %s"),proto)
#line 572
);
#line 575
	}

	fd = socket(addr.sa.sa_family, SOCK_STREAM, 0);
		if (!(fd != -1))
#line 578
		(
#line 578
	env_throw_bi(env, mfe_failure, NULL, _("unable to create new socket: %s"),strerror(errno))
#line 578
)
#line 581
;

	/* FIXME: Bind to the source ? */

	rc = connect(fd, &addr.sa, socklen);
	if (rc) {
		close(fd);
		(
#line 588
	env_throw_bi(env, mfe_failure, NULL, _("cannot connect to %s: %s"),cstr,strerror(errno))
#line 588
);
#line 591
	}
	
	str->fd[0] = fd;
	return 0;
}

static int
shutdown_inet_stream(struct io_stream *str, int how)
{
	switch (how) {
	case 0:
		how = SHUT_RD;
		break;

	case 1:
		how = SHUT_WR;
		break;

	case 2:
		how = SHUT_RDWR;
		break;

	default:
		return EINVAL;
	}
	if (shutdown(str->fd[0], how))
		return errno;
	return 0;
}

static int
open_inet_stream(eval_environ_t env,
		 struct io_stream *str, const char *addr, int flags)
{
	int rc;
	char *proto, *port, *path;

	if (gacopyz_parse_connection(addr, &proto, &port, &path)
	    != MI_SUCCESS) 
		rc = ENOMEM; /* FIXME: or EINVAL? */
	else {
		rc = open_parsed_inet_stream(env,
					     str, addr,
					     proto, port, path, flags);
		str->shutdown = shutdown_inet_stream;
		free(proto);
		free(port);
		free(path);
	}
	return rc;
}


static void *
alloc_streams()
{
	struct io_stream *p, *stab = mu_calloc(nstreams, sizeof *stab);
	for (p = stab; p < stab + nstreams; p++) 
		p->fd[0] = p->fd[1] = -1;
	return stab;
}

static void
destroy_streams(void *data)
{
	struct io_stream *stab = data;
	struct io_stream *p;
	for (p = stab; p < stab + nstreams; p++) {
		close_stream(p);
		free(p->buf);
	}
	free(stab);
}
		

#line 665

#line 665
static int IO_id;
#line 665 "io.bi"


int
_bi_io_fd(eval_environ_t env, int fd, int what)
{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int descr;

		if (!(fd >= 0 && fd < nstreams && what>=0 && what<=1))
#line 673
		(
#line 673
	env_throw_bi(env, mfe_range, NULL, _("invalid file descriptor"))
#line 673
)
#line 675
;
	descr = what == 0 ? IFD(iotab[fd]) : OFD(iotab[fd]);
		if (!(descr >= 0))
#line 677
		(
#line 677
	env_throw_bi(env, mfe_range, NULL, _("invalid file descriptor"))
#line 677
)
#line 679
;
	return descr;
}


void
#line 684
bi_open(eval_environ_t env)
#line 684

#line 684

#line 684 "io.bi"
{
#line 684
	
#line 684

#line 684

#line 684
char *  name;
#line 684
        
#line 684
get_string_arg(env, 0, &name);
#line 684
        
#line 684

#line 684
        adjust_stack(env, 1);
#line 684

#line 684

#line 684
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 684
		prog_trace(env, "open %s",name);;
#line 684

{
	int i, rc;
	int flags = 0;
	int (*opf)(eval_environ_t env,
		   struct io_stream *, const char *, int) = open_file_stream;
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	
	for (i = 0; i < nstreams; i++) {
		if (iotab[i].fd[0] == -1) 
			break;
	}
		if (!(i < nstreams))
#line 696
		(
#line 696
	env_throw_bi(env, mfe_failure, "open", _("no more files available"))
#line 696
)
#line 698
;

	
#line 700

#line 700
mu_debug(debug_handle, 10,("opening stream %s", name));
	iotab[i].name = mu_strdup(name);
	iotab[i].delim = NULL;
	if (*name == '>') {
		flags |= O_RDWR|O_CREAT;
		name++;
		if (*name == '>') {
			flags |= O_APPEND;
			name++;
		} else
			flags |= O_TRUNC;
	} else if (*name == '|') {
		opf = open_program_stream;
		flags = O_WRONLY;
		name++;
		if (*name == '&') {
			flags = O_RDWR;
			name++;
		} else if (*name == '<') {
			flags = O_RDONLY;
			name++;
		}
	} else if (*name == '@') {
		name++;
		opf = open_inet_stream;
		flags = O_RDWR;
	} else
		flags = O_RDONLY;
	
	for (;*name && mu_isspace(*name); name++)
		;
	
	rc = opf(env, &iotab[i], name, flags);
	
		if (!(rc == 0))
#line 734
		(
#line 734
	env_throw_bi(env, mfe_failure, "open", _("cannot open stream %s: %s"),name,mu_strerror(rc))
#line 734
)
#line 737
;
	
#line 738

#line 738
mu_debug(debug_handle, 10,("open(%s) = %d", name, i));
	
#line 739
do {
#line 739
  push(env, (STKVAL)(mft_number)(i));
#line 739
  goto endlab;
#line 739
} while (0);
}
endlab:
#line 741
        env_function_cleanup_flush(env, NULL);
#line 741
	return;
#line 741
}

void
#line 743
bi_spawn(eval_environ_t env)
#line 743

#line 743

#line 743 "io.bi"
{
#line 743
	
#line 743

#line 743
long __bi_argcnt;
#line 743
char *  name;
#line 743
        long  fin;
#line 743
        long  fout;
#line 743
        long  ferr;
#line 743
        
#line 743
get_string_arg(env, 1, &name);
#line 743
        get_numeric_arg(env, 2, &fin);
#line 743
        get_numeric_arg(env, 3, &fout);
#line 743
        get_numeric_arg(env, 4, &ferr);
#line 743
        
#line 743
get_numeric_arg(env, 0, &__bi_argcnt);
#line 743
        adjust_stack(env, __bi_argcnt + 1);
#line 743

#line 743

#line 743
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 743
		prog_trace(env, "spawn %s %lu %lu %lu",name, ((__bi_argcnt > 1) ? fin : 0), ((__bi_argcnt > 2) ? fout : 0), ((__bi_argcnt > 3) ? ferr : 0));;

{
	int i, rc;
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int ioe[3];
	int flags;
	
	for (i = 0; i < nstreams; i++) {
		if (iotab[i].fd[0] == -1) 
			break;
	}
		if (!(i < nstreams))
#line 755
		(
#line 755
	env_throw_bi(env, mfe_failure, "spawn", _("no more files available"))
#line 755
)
#line 757
;

	
#line 759

#line 759
mu_debug(debug_handle, 10,("spawning %s", name));
	iotab[i].name = mu_strdup(name);
	iotab[i].delim = NULL;

	flags = O_WRONLY;
	if (*name == '|')
		name++;
	if (*name == '&') {
		flags = O_RDWR;
		name++;
	} else if (*name == '<') {
		flags = O_RDONLY;
		name++;
	}

	for (;*name && mu_isspace(*name); name++)
		;

	if ((__bi_argcnt > 1))
		ioe[0] = _bi_io_fd(env, ((__bi_argcnt > 1) ? fin : 0), 0);
	else
		ioe[0] = -1;
	if ((__bi_argcnt > 2))
		ioe[1] = _bi_io_fd(env, ((__bi_argcnt > 2) ? fout : 0), 1);
	else
		ioe[1] = -1;
	if ((__bi_argcnt > 3))
		ioe[2] = _bi_io_fd(env, ((__bi_argcnt > 2) ? fout : 0), 1);
	else
		ioe[2] = -1;
	
	rc = open_program_stream_ioe(env, &iotab[i], name, flags, ioe);
	
		if (!(rc == 0))
#line 792
		(
#line 792
	env_throw_bi(env, mfe_failure, "spawn", _("cannot open stream %s: %s"),name,mu_strerror(rc))
#line 792
)
#line 795
;
	
#line 796

#line 796
mu_debug(debug_handle, 10,("spawn(%s) = %d", name, i));
	
#line 797
do {
#line 797
  push(env, (STKVAL)(mft_number)(i));
#line 797
  goto endlab;
#line 797
} while (0);
	
}
endlab:
#line 800
        env_function_cleanup_flush(env, NULL);
#line 800
	return;
#line 800
}


void
#line 803
bi_tempfile(eval_environ_t env)
#line 803

#line 803

#line 803 "io.bi"
{
#line 803
	
#line 803

#line 803
long __bi_argcnt;
#line 803
char * MFL_DATASEG tempdir;
#line 803
        
#line 803
get_string_arg(env, 1, &tempdir);
#line 803
        
#line 803
get_numeric_arg(env, 0, &__bi_argcnt);
#line 803
        adjust_stack(env, __bi_argcnt + 1);
#line 803

#line 803

#line 803
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 803
		prog_trace(env, "tempfile %s",((__bi_argcnt > 0) ? tempdir : ""));;
#line 803

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int i;
	char *dir = ((__bi_argcnt > 0) ? tempdir : "/tmp");
	size_t dirlen = strlen(dir);
	mode_t u;
	int fd;
	char *template;
#define PATTERN "mfdXXXXXX"

	for (i = 0; i < nstreams; i++) {
		if (iotab[i].fd[0] == -1) 
			break;
	}
		if (!(i < nstreams))
#line 818
		(
#line 818
	env_throw_bi(env, mfe_failure, "tempfile", _("no more files available"))
#line 818
)
#line 820
;


	while (dirlen > 0 && dir[dirlen-1] == '/')
		dirlen--;

	template = mf_c_val(heap_tempspace(env, (dirlen ? dirlen + 1 : 0) +
#line 826
				      sizeof(PATTERN)), ptr);
#line 828
	if (dirlen) {
		memcpy(template, dir, dirlen);
		template[dirlen++] = '/';
	}
	strcpy(template + dirlen, PATTERN);
	u = umask(077);
	fd = mkstemp(template);
	umask(u);
		if (!(fd >= 0))
#line 836
		(
#line 836
	env_throw_bi(env, mfe_failure, "tempfile", "mkstemp failed: %s",mu_strerror(errno))
#line 836
)
#line 839
;
	unlink(template);

	iotab[i].fd[0] = fd;
	
	
#line 844
do {
#line 844
  push(env, (STKVAL)(mft_number)(i));
#line 844
  goto endlab;
#line 844
} while (0);
#undef PATTERN
}
endlab:
#line 847
        env_function_cleanup_flush(env, NULL);
#line 847
	return;
#line 847
}

void
#line 849
bi_close(eval_environ_t env)
#line 849

#line 849

#line 849 "io.bi"
{
#line 849
	
#line 849

#line 849

#line 849
long  fd;
#line 849
        
#line 849
get_numeric_arg(env, 0, &fd);
#line 849
        
#line 849

#line 849
        adjust_stack(env, 1);
#line 849

#line 849

#line 849
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 849
		prog_trace(env, "close %lu",fd);;
#line 849

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);

		if (!(fd >= 0 && fd < nstreams))
#line 853
		(
#line 853
	env_throw_bi(env, mfe_range, "close", _("invalid file descriptor"))
#line 853
)
#line 855
;
	close_stream(&iotab[fd]);
}

#line 858
        env_function_cleanup_flush(env, NULL);
#line 858
	return;
#line 858
}	

static struct builtin_const_trans shutdown_modes[] = {
	{ _MFL_SHUT_RD, SHUT_RD },
	{ _MFL_SHUT_WR, SHUT_WR },
	{ _MFL_SHUT_RDWR, SHUT_RDWR }
};

void
#line 866
bi_shutdown(eval_environ_t env)
#line 866

#line 866

#line 866 "io.bi"
{
#line 866
	
#line 866

#line 866

#line 866
long  fd;
#line 866
        long  how;
#line 866
        
#line 866
get_numeric_arg(env, 0, &fd);
#line 866
        get_numeric_arg(env, 1, &how);
#line 866
        
#line 866

#line 866
        adjust_stack(env, 2);
#line 866

#line 866

#line 866
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 866
		prog_trace(env, "shutdown %lu %lu",fd, how);;
#line 866

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;
	int mode;
	
		if (!(fd >= 0 && fd < nstreams))
#line 872
		(
#line 872
	env_throw_bi(env, mfe_range, "shutdown", _("invalid file descriptor"))
#line 872
)
#line 874
;
		if (!(how >= 0 && how <= 2))
#line 875
		(
#line 875
	env_throw_bi(env, mfe_range, "shutdown", _("invalid file descriptor"))
#line 875
)
#line 877
;
		if (!(_builtin_const_to_c(shutdown_modes,
#line 878
				      MU_ARRAY_SIZE(shutdown_modes),
#line 878
				      how,
#line 878
				      &mode) == 0))
#line 878
		(
#line 878
	env_throw_bi(env, mfe_failure, "shutdown", "bad shutdown mode")
#line 878
)
#line 883
;
	
	ioptr = &iotab[fd];
	if (ioptr->shutdown) {
		int rc = ioptr->shutdown(ioptr, mode);
			if (!(rc == 0))
#line 888
		(
#line 888
	env_throw_bi(env, mfe_io, "shutdown", "shutdown failed: %s",mu_strerror(rc))
#line 888
)
#line 891
;
	} else if (how == 2)
		close_stream(ioptr);
	else if (ioptr->fd[how]) {
		close(ioptr->fd[how]);
		ioptr->fd[how] = -1;
	}
}

#line 899
        env_function_cleanup_flush(env, NULL);
#line 899
	return;
#line 899
}

void
#line 901
bi_write(eval_environ_t env)
#line 901

#line 901

#line 901 "io.bi"
{
#line 901
	
#line 901

#line 901
long __bi_argcnt;
#line 901
long  fd;
#line 901
        char *  str;
#line 901
        long  n;
#line 901
        
#line 901
get_numeric_arg(env, 1, &fd);
#line 901
        get_string_arg(env, 2, &str);
#line 901
        get_numeric_arg(env, 3, &n);
#line 901
        
#line 901
get_numeric_arg(env, 0, &__bi_argcnt);
#line 901
        adjust_stack(env, __bi_argcnt + 1);
#line 901

#line 901

#line 901
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 901
		prog_trace(env, "write %lu %s %lu",fd, str, ((__bi_argcnt > 2) ? n : 0));;
#line 901

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int rc;
	
	
#line 906

#line 906
mu_debug(debug_handle, 10,("writing %s to %lu", str, fd));
		if (!(fd >= 0 && fd < nstreams && OFD(iotab[fd]) != -1))
#line 907
		(
#line 907
	env_throw_bi(env, mfe_range, "write", _("invalid file descriptor"))
#line 907
)
#line 909
;
	if (!(__bi_argcnt > 2))
		n = strlen (str);
	rc = write(OFD(iotab[fd]), str, n);
		if (!(n == rc))
#line 913
		(
#line 913
	env_throw_bi(env, mfe_io, "write", _("write error on %s: %s"),iotab[fd].name,mu_strerror(errno))
#line 913
)
#line 916
;
}

#line 918
        env_function_cleanup_flush(env, NULL);
#line 918
	return;
#line 918
}


void
#line 921
bi_write_body(eval_environ_t env)
#line 921

#line 921

#line 921 "io.bi"
{
#line 921
	
#line 921

#line 921

#line 921
long  fd;
#line 921
        void *  str;
#line 921
        long  n;
#line 921
        
#line 921
get_numeric_arg(env, 0, &fd);
#line 921
        get_pointer_arg(env, 1, &str);
#line 921
        get_numeric_arg(env, 2, &n);
#line 921
        
#line 921

#line 921
        adjust_stack(env, 3);
#line 921

#line 921

#line 921
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 921
		prog_trace(env, "write_body %lu %p %lu",fd, str, n);;
#line 921

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int rc;

		if (!(fd >= 0 && fd < nstreams && OFD(iotab[fd]) != -1))
#line 926
		(
#line 926
	env_throw_bi(env, mfe_range, "write_body", _("invalid file descriptor"))
#line 926
)
#line 928
;
	rc = write(OFD(iotab[fd]), str, n);
		if (!(n == rc))
#line 930
		(
#line 930
	env_throw_bi(env, mfe_io, "write_body", _("write error on %s: %s"),iotab[fd].name,mu_strerror(errno))
#line 930
)
#line 933
;
}

#line 935
        env_function_cleanup_flush(env, NULL);
#line 935
	return;
#line 935
}

void
#line 937
bi_read(eval_environ_t env)
#line 937

#line 937

#line 937 "io.bi"
{
#line 937
	
#line 937

#line 937

#line 937
long  fd;
#line 937
        long  size;
#line 937
        
#line 937
get_numeric_arg(env, 0, &fd);
#line 937
        get_numeric_arg(env, 1, &size);
#line 937
        
#line 937

#line 937
        adjust_stack(env, 2);
#line 937

#line 937

#line 937
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 937
		prog_trace(env, "read %lu %lu",fd, size);;
#line 937

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int rc;
	size_t off;
	char *s = (char*) env_data_ref(env, (off = heap_reserve(env, size + 1)));

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 944
		(
#line 944
	env_throw_bi(env, mfe_range, "read", _("invalid file descriptor"))
#line 944
)
#line 946
;
	
	rc = read(IFD(iotab[fd]), s, size);
	if (rc == 0)
		(
#line 950
	env_throw_bi(env, mfe_eof, "read", _("EOF on %s"),iotab[fd].name)
#line 950
);
#line 952
		if (!(rc == size))
#line 952
		(
#line 952
	env_throw_bi(env, mfe_io, "read", _("read error on %s: %s"),iotab[fd].name,mu_strerror(errno))
#line 952
)
#line 955
;
	s[size] = 0;
	
#line 957
do {
#line 957
  push(env, (STKVAL) (mft_size) (off));
#line 957
  goto endlab;
#line 957
} while (0);
}	
endlab:
#line 959
        env_function_cleanup_flush(env, NULL);
#line 959
	return;
#line 959
}

void
#line 961
bi_rewind(eval_environ_t env)
#line 961

#line 961

#line 961 "io.bi"
{
#line 961
	
#line 961

#line 961

#line 961
long  fd;
#line 961
        
#line 961
get_numeric_arg(env, 0, &fd);
#line 961
        
#line 961

#line 961
        adjust_stack(env, 1);
#line 961

#line 961

#line 961
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 961
		prog_trace(env, "rewind %lu",fd);;
#line 961

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 965
		(
#line 965
	env_throw_bi(env, mfe_range, "rewind", _("invalid file descriptor"))
#line 965
)
#line 967
;
	if (lseek(IFD(iotab[fd]), 0, SEEK_SET) == -1)
		(
#line 969
	env_throw_bi(env, mfe_io, "rewind", "seek failed: %s",mu_strerror(errno))
#line 969
);
#line 972
}

#line 973
        env_function_cleanup_flush(env, NULL);
#line 973
	return;
#line 973
}
	

#define MINBUFSIZE 128
#define MAXBUFSIZE 65535

void
#line 979
bi_copy(eval_environ_t env)
#line 979

#line 979

#line 979 "io.bi"
{
#line 979
	
#line 979

#line 979

#line 979
long  dst;
#line 979
        long  src;
#line 979
        
#line 979
get_numeric_arg(env, 0, &dst);
#line 979
        get_numeric_arg(env, 1, &src);
#line 979
        
#line 979

#line 979
        adjust_stack(env, 2);
#line 979

#line 979

#line 979
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 979
		prog_trace(env, "copy %lu %lu",dst, src);;
#line 979

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int ifd, ofd;
	char *buffer;
	size_t bufsize = MAXBUFSIZE;
	char bs[MINBUFSIZE];
	off_t cur, end;
	size_t total = 0;
	ssize_t rdbytes;
	
		if (!(src >= 0 && src < nstreams && (ifd = IFD(iotab[src])) != -1))
#line 990
		(
#line 990
	env_throw_bi(env, mfe_range, "copy", _("invalid source file descriptor"))
#line 990
)
#line 992
;
		if (!(dst >= 0 && dst < nstreams && (ofd = OFD(iotab[dst])) != -1))
#line 993
		(
#line 993
	env_throw_bi(env, mfe_range, "copy", _("invalid destination file descriptor"))
#line 993
)
#line 995
;

	cur = lseek (ifd, 0, SEEK_CUR);
	if (cur != -1) {
		end = lseek (ifd, 0, SEEK_END);
		if (end != -1) {
			if (end < MAXBUFSIZE)
				bufsize = end;
			lseek (ifd, cur, SEEK_SET);
		}
	}

	for (; (buffer = malloc (bufsize)) == NULL; bufsize >>= 1)
		if (bufsize < MINBUFSIZE) {
			buffer = bs;
			bufsize = MINBUFSIZE;
			break;
		}

	while ((rdbytes = read(ifd, buffer, bufsize)) > 0) {
		char *p = buffer;
		while (rdbytes) {
			ssize_t wrbytes = write(ofd, p, rdbytes);
			if (wrbytes == -1) {
				if (buffer != bs)
					free(buffer);
				(
#line 1021
	env_throw_bi(env, mfe_io, "copy", "write error: %s",mu_strerror(errno))
#line 1021
);
#line 1024
			} else if (wrbytes == 0) {
				if (buffer != bs)
					free(buffer);
				(
#line 1027
	env_throw_bi(env, mfe_io, "copy", "short write")
#line 1027
);
#line 1029
			}
			p += wrbytes;
			rdbytes -= wrbytes;
			total += wrbytes;
		}
	}
	if (buffer != bs)
		free(buffer);
	
#line 1037
do {
#line 1037
  push(env, (STKVAL)(mft_number)(total));
#line 1037
  goto endlab;
#line 1037
} while (0);
}
endlab:
#line 1039
        env_function_cleanup_flush(env, NULL);
#line 1039
	return;
#line 1039
}

void
#line 1041
bi_getdelim(eval_environ_t env)
#line 1041

#line 1041

#line 1041 "io.bi"
{
#line 1041
	
#line 1041

#line 1041

#line 1041
long  fd;
#line 1041
        char * MFL_DATASEG delim;
#line 1041
        
#line 1041
get_numeric_arg(env, 0, &fd);
#line 1041
        get_string_arg(env, 1, &delim);
#line 1041
        
#line 1041

#line 1041
        adjust_stack(env, 2);
#line 1041

#line 1041

#line 1041
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 1041
		prog_trace(env, "getdelim %lu %s",fd, delim);;
#line 1041

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;
	int rc;
	
		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 1047
		(
#line 1047
	env_throw_bi(env, mfe_range, "getdelim", _("invalid file descriptor"))
#line 1047
)
#line 1049
;
	ioptr = &iotab[fd];
	rc = read_stream_delim(ioptr, delim); 
	if (rc == 0)
		(
#line 1053
	env_throw_bi(env, mfe_eof, "getdelim", _("EOF on %s"),ioptr->name)
#line 1053
);
		if (!(rc > 0))
#line 1054
		(
#line 1054
	env_throw_bi(env, mfe_io, "getdelim", _("read error on %s: %s"),ioptr->name,mu_strerror(errno))
#line 1054
)
#line 1057
;
	
#line 1058
do {
#line 1058
  pushs(env, ioptr->buf);
#line 1058
  goto endlab;
#line 1058
} while (0);
}	
endlab:
#line 1060
        env_function_cleanup_flush(env, NULL);
#line 1060
	return;
#line 1060
}

void
#line 1062
bi_getline(eval_environ_t env)
#line 1062

#line 1062

#line 1062 "io.bi"
{
#line 1062
	
#line 1062

#line 1062

#line 1062
long  fd;
#line 1062
        
#line 1062
get_numeric_arg(env, 0, &fd);
#line 1062
        
#line 1062

#line 1062
        adjust_stack(env, 1);
#line 1062

#line 1062

#line 1062
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 1062
		prog_trace(env, "getline %lu",fd);;
#line 1062

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;
	int rc;

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 1068
		(
#line 1068
	env_throw_bi(env, mfe_range, "getline", _("invalid file descriptor"))
#line 1068
)
#line 1070
;
	ioptr = &iotab[fd];
	rc = read_stream_delim(ioptr, ioptr->delim ? ioptr->delim : "\n");
	if (rc == 0)
		(
#line 1074
	env_throw_bi(env, mfe_eof, "getline", _("EOF on %s"),ioptr->name)
#line 1074
);
#line 1076
		if (!(rc > 0))
#line 1076
		(
#line 1076
	env_throw_bi(env, mfe_io, "getline", _("read error on %s: %s"),ioptr->name,mu_strerror(errno))
#line 1076
)
#line 1079
;
	
#line 1080
do {
#line 1080
  pushs(env, ioptr->buf);
#line 1080
  goto endlab;
#line 1080
} while (0);
}	
endlab:
#line 1082
        env_function_cleanup_flush(env, NULL);
#line 1082
	return;
#line 1082
}

void
#line 1084
bi_fd_set_delimiter(eval_environ_t env)
#line 1084

#line 1084

#line 1084 "io.bi"
{
#line 1084
	
#line 1084

#line 1084

#line 1084
long  fd;
#line 1084
        char *  delim;
#line 1084
        
#line 1084
get_numeric_arg(env, 0, &fd);
#line 1084
        get_string_arg(env, 1, &delim);
#line 1084
        
#line 1084

#line 1084
        adjust_stack(env, 2);
#line 1084

#line 1084

#line 1084
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 1084
		prog_trace(env, "fd_set_delimiter %lu %s",fd, delim);;
#line 1084

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 1089
		(
#line 1089
	env_throw_bi(env, mfe_range, "fd_set_delimiter", _("invalid file descriptor"))
#line 1089
)
#line 1091
;
	ioptr = &iotab[fd];
	free(ioptr->delim);
	ioptr->delim = mu_strdup(delim);
}

#line 1096
        env_function_cleanup_flush(env, NULL);
#line 1096
	return;
#line 1096
}

void
#line 1098
bi_fd_delimiter(eval_environ_t env)
#line 1098

#line 1098

#line 1098 "io.bi"
{
#line 1098
	
#line 1098

#line 1098

#line 1098
long  fd;
#line 1098
        char * MFL_DATASEG delim;
#line 1098
        
#line 1098
get_numeric_arg(env, 0, &fd);
#line 1098
        get_string_arg(env, 1, &delim);
#line 1098
        
#line 1098

#line 1098
        adjust_stack(env, 2);
#line 1098

#line 1098

#line 1098
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 1098
		prog_trace(env, "fd_delimiter %lu %s",fd, delim);;
#line 1098

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 1103
		(
#line 1103
	env_throw_bi(env, mfe_range, "fd_delimiter", _("invalid file descriptor"))
#line 1103
)
#line 1105
;
	ioptr = &iotab[fd];
	
#line 1107
do {
#line 1107
  pushs(env, ioptr->delim ? ioptr->delim : "\n");
#line 1107
  goto endlab;
#line 1107
} while (0);
}
endlab:
#line 1109
        env_function_cleanup_flush(env, NULL);
#line 1109
	return;
#line 1109
}


#line 1111
void
#line 1111
io_init_builtin()
#line 1111
{
#line 1111
		debug_handle = mu_debug_register_category("bi_io");
#line 1111

#line 1111
	#line 665 "io.bi"
IO_id = builtin_priv_register(alloc_streams, destroy_streams,
#line 665
NULL);
#line 684 "io.bi"
va_builtin_install_ex("open", bi_open, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 743 "io.bi"
va_builtin_install_ex("spawn", bi_spawn, 0, dtype_number, 4, 3, 0|0, dtype_string, dtype_number, dtype_number, dtype_number);
#line 803 "io.bi"
va_builtin_install_ex("tempfile", bi_tempfile, 0, dtype_number, 1, 1, 0|0, dtype_string);
#line 849 "io.bi"
va_builtin_install_ex("close", bi_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 866 "io.bi"
va_builtin_install_ex("shutdown", bi_shutdown, 0, dtype_unspecified, 2, 0, 0|0, dtype_number, dtype_number);
#line 901 "io.bi"
va_builtin_install_ex("write", bi_write, 0, dtype_unspecified, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 921 "io.bi"
va_builtin_install_ex("write_body", bi_write_body, STATMASK(smtp_state_body), dtype_unspecified, 3, 0, 0|0, dtype_number, dtype_pointer, dtype_number);
#line 937 "io.bi"
va_builtin_install_ex("read", bi_read, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 961 "io.bi"
va_builtin_install_ex("rewind", bi_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 979 "io.bi"
va_builtin_install_ex("copy", bi_copy, 0, dtype_number, 2, 0, 0|0, dtype_number, dtype_number);
#line 1041 "io.bi"
va_builtin_install_ex("getdelim", bi_getdelim, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_string);
#line 1062 "io.bi"
va_builtin_install_ex("getline", bi_getline, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 1084 "io.bi"
va_builtin_install_ex("fd_set_delimiter", bi_fd_set_delimiter, 0, dtype_unspecified, 2, 0, 0|0, dtype_number, dtype_string);
#line 1098 "io.bi"
va_builtin_install_ex("fd_delimiter", bi_fd_delimiter, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_string);

#line 1111 "io.bi"
	
#line 1111
	 mf_add_runtime_params(io_cfg_param);
#line 1111
	 
#line 1111
}
#line 1111 "io.bi"

#line 1113

#line 761 "../../src/builtin/snarf.m4"

#line 761

