/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 116
#ifdef HAVE_CONFIG_H
#line 116
# include <config.h>
#line 116
#endif
#line 116
#include <sys/types.h>
#line 116

#line 116
#include "mailfromd.h"
#line 116
#include "prog.h"
#line 116
#include "builtin.h"
#line 116

#line 116

#line 767 "../../src/builtin/snarf.m4"

#line 1 "vars.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006-2011, 2015 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "filenames.h" /* For DEFAULT_FROM_ADDRESS */
static size_t rcpt_count_loc
#line 18 "vars.bi"
;
static size_t milter_client_family_loc
#line 19 "vars.bi"
;
static size_t milter_client_address_loc
#line 20 "vars.bi"
;
static size_t milter_server_family_loc
#line 21 "vars.bi"
;
static size_t milter_server_address_loc
#line 22 "vars.bi"
;
static size_t milter_server_id_loc
#line 23 "vars.bi"
;
static size_t sendmail_header_count_loc
#line 24 "vars.bi"
;

/* Functions to access %rcpt_count */
unsigned long
get_rcpt_count(eval_environ_t env)
{
 	return mf_c_val(*env_data_ref(env, rcpt_count_loc),long) ;
}

void
clear_rcpt_count(eval_environ_t env)
{
	mf_c_val(*env_data_ref(env, rcpt_count_loc),long) = (0);
}

void
incr_rcpt_count(eval_environ_t env)
{
	env_var_inc(env, rcpt_count_loc);
}

/* Same for sendmail_header_count */
unsigned long
get_sendmail_header_count(eval_environ_t env)
{
 	return mf_c_val(*env_data_ref(env, sendmail_header_count_loc),long) ;
}

void
set_sendmail_header_count(eval_environ_t env, unsigned long v)
{
 	mf_c_val(*env_data_ref(env, sendmail_header_count_loc),ulong) = (v);
}

/* define_milter_address name */
#line 103

	  

#line 105

#line 105
void
#line 105
set_milter_server_address(eval_environ_t env, milter_sockaddr_t *addr,
#line 105
		      socklen_t len)
#line 105
{
#line 105
	char *path;
#line 105
	
#line 105
	switch (addr->sa.sa_family) {
#line 105
	case PF_INET:
#line 105
		mf_c_val(*env_data_ref(env, milter_server_family_loc),long) = (MFAM_INET);
#line 105
		
#line 105
{ size_t __off;
#line 105
  const char *__s = inet_ntoa(addr->sin.sin_addr);
#line 105
  if (__s)
#line 105
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 105
  else
#line 105
     __off = 0;
#line 105
  mf_c_val(*env_data_ref(env, milter_server_address_loc),size) = (__off); }
#line 105
;
#line 105
		break;
#line 105

#line 105
#ifdef GACOPYZ_IPV6
#line 105
	case PF_INET6: {
#line 105
		char hostbuf[NI_MAXHOST];
#line 105

#line 105
		mf_c_val(*env_data_ref(env, milter_server_family_loc),long) = (MFAM_INET6);
#line 105
		if (getnameinfo(&addr->sa, sizeof(addr->sin6),
#line 105
				hostbuf, sizeof hostbuf,
#line 105
				NULL, 0,
#line 105
				NI_NUMERICHOST|NI_NUMERICSERV))
#line 105
			hostbuf[0] = 0;
#line 105
		
#line 105
{ size_t __off;
#line 105
  const char *__s = hostbuf;
#line 105
  if (__s)
#line 105
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 105
  else
#line 105
     __off = 0;
#line 105
  mf_c_val(*env_data_ref(env, milter_server_address_loc),size) = (__off); }
#line 105
;
#line 105
		break;
#line 105
	}
#line 105
#endif
#line 105
		
#line 105
	case PF_UNIX:
#line 105
		mf_c_val(*env_data_ref(env, milter_server_family_loc),long) = (MFAM_UNIX);
#line 105
		if (len == sizeof (addr->sa.sa_family))
#line 105
			path = "";
#line 105
		else
#line 105
			path = addr->sunix.sun_path;
#line 105
		
#line 105
{ size_t __off;
#line 105
  const char *__s = path;
#line 105
  if (__s)
#line 105
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 105
  else
#line 105
     __off = 0;
#line 105
  mf_c_val(*env_data_ref(env, milter_server_address_loc),size) = (__off); }
#line 105
;
#line 105
		break;
#line 105
		
#line 105
	default:
#line 105
		/* FIXME */
#line 105
		mf_c_val(*env_data_ref(env, milter_server_family_loc),long) = ((long)addr->sa.sa_family);
#line 105
	}
#line 105
}
#line 105

#line 105

#line 105

#line 105


#line 106

#line 106
void
#line 106
set_milter_client_address(eval_environ_t env, milter_sockaddr_t *addr,
#line 106
		      socklen_t len)
#line 106
{
#line 106
	char *path;
#line 106
	
#line 106
	switch (addr->sa.sa_family) {
#line 106
	case PF_INET:
#line 106
		mf_c_val(*env_data_ref(env, milter_client_family_loc),long) = (MFAM_INET);
#line 106
		
#line 106
{ size_t __off;
#line 106
  const char *__s = inet_ntoa(addr->sin.sin_addr);
#line 106
  if (__s)
#line 106
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 106
  else
#line 106
     __off = 0;
#line 106
  mf_c_val(*env_data_ref(env, milter_client_address_loc),size) = (__off); }
#line 106
;
#line 106
		break;
#line 106

#line 106
#ifdef GACOPYZ_IPV6
#line 106
	case PF_INET6: {
#line 106
		char hostbuf[NI_MAXHOST];
#line 106

#line 106
		mf_c_val(*env_data_ref(env, milter_client_family_loc),long) = (MFAM_INET6);
#line 106
		if (getnameinfo(&addr->sa, sizeof(addr->sin6),
#line 106
				hostbuf, sizeof hostbuf,
#line 106
				NULL, 0,
#line 106
				NI_NUMERICHOST|NI_NUMERICSERV))
#line 106
			hostbuf[0] = 0;
#line 106
		
#line 106
{ size_t __off;
#line 106
  const char *__s = hostbuf;
#line 106
  if (__s)
#line 106
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 106
  else
#line 106
     __off = 0;
#line 106
  mf_c_val(*env_data_ref(env, milter_client_address_loc),size) = (__off); }
#line 106
;
#line 106
		break;
#line 106
	}
#line 106
#endif
#line 106
		
#line 106
	case PF_UNIX:
#line 106
		mf_c_val(*env_data_ref(env, milter_client_family_loc),long) = (MFAM_UNIX);
#line 106
		if (len == sizeof (addr->sa.sa_family))
#line 106
			path = "";
#line 106
		else
#line 106
			path = addr->sunix.sun_path;
#line 106
		
#line 106
{ size_t __off;
#line 106
  const char *__s = path;
#line 106
  if (__s)
#line 106
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 106
  else
#line 106
     __off = 0;
#line 106
  mf_c_val(*env_data_ref(env, milter_client_address_loc),size) = (__off); }
#line 106
;
#line 106
		break;
#line 106
		
#line 106
	default:
#line 106
		/* FIXME */
#line 106
		mf_c_val(*env_data_ref(env, milter_client_family_loc),long) = ((long)addr->sa.sa_family);
#line 106
	}
#line 106
}
#line 106

#line 106

#line 106

#line 106



#line 108

#line 108
void
#line 108
set_milter_server_id(eval_environ_t env, const char *id)
#line 108
{
#line 108
	
#line 108
{ size_t __off;
#line 108
  const char *__s = id ? id : "";
#line 108
  if (__s)
#line 108
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 108
  else
#line 108
     __off = 0;
#line 108
  mf_c_val(*env_data_ref(env, milter_server_id_loc),size) = (__off); }
#line 108
;
#line 108
}
#line 108

#line 108

#line 108

#line 114



#line 116
void
#line 116
vars_init_builtin()
#line 116
{
#line 116
	
#line 116
	#line 18 "vars.bi"
	builtin_variable_install("rcpt_count", dtype_number, SYM_VOLATILE, &rcpt_count_loc);
#line 19 "vars.bi"
	builtin_variable_install("milter_client_family", dtype_number, SYM_VOLATILE|SYM_PRECIOUS, &milter_client_family_loc);
#line 20 "vars.bi"
	builtin_variable_install("milter_client_address", dtype_string, SYM_VOLATILE|SYM_PRECIOUS, &milter_client_address_loc);
#line 21 "vars.bi"
	builtin_variable_install("milter_server_family", dtype_number, SYM_VOLATILE|SYM_PRECIOUS, &milter_server_family_loc);
#line 22 "vars.bi"
	builtin_variable_install("milter_server_address", dtype_string, SYM_VOLATILE|SYM_PRECIOUS, &milter_server_address_loc);
#line 23 "vars.bi"
	builtin_variable_install("milter_server_id", dtype_string, SYM_VOLATILE|SYM_PRECIOUS, &milter_server_id_loc);
#line 24 "vars.bi"
	builtin_variable_install("sendmail_header_count", dtype_number, SYM_VOLATILE|SYM_PRECIOUS, &sendmail_header_count_loc);

#line 116 "vars.bi"
	
#line 116
}
#line 116 "vars.bi"

#line 116

#line 761 "../../src/builtin/snarf.m4"

#line 761

